HDU 1010 Tempter of the Bone

Tempter of the Bone
Time Limit: 2000/1000 MS (Java/Others) Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 44574 Accepted Submission(s): 12043

Problem Description
The doggie found a bone in an ancient maze, which fascinated him a lot. However, when he picked it up, the maze began to shake, and the doggie could feel the ground sinking. He realized that the bone was a trap, and he tried desperately to get out of this maze.

The maze was a rectangle with sizes N by M. There was a door in the maze. At the beginning, the door was closed and it would open at the T-th second for a short period of time (less than 1 second). Therefore the doggie had to arrive at the door on exactly the T-th second. In every second, he could move one block to one of the upper, lower, left and right neighboring blocks. Once he entered a block, the ground of this block would start to sink and disappear in the next second. He could not stay at one block for more than one second, nor could he move into a visited block. Can the poor doggie survive? Please help him.

Input
The input consists of multiple test cases. The first line of each test case contains three integers N, M, and T (1 < N, M < 7; 0 < T < 50), which denote the sizes of the maze and the time at which the door will open, respectively. The next N lines give the maze layout, with each line containing M characters. A character is one of the following:

‘X’: a block of wall, which the doggie cannot enter;
‘S’: the start point of the doggie;
‘D’: the Door; or
‘.’: an empty block.

The input is terminated with three 0’s. This test case is not to be processed.

Output
For each test case, print in one line “YES” if the doggie can survive, or “NO” otherwise.

Sample Input
4 4 5
S.X.
..X.
..XD
….
3 4 5
S.X.
..X.
…D
0 0 0

Sample Output
NO
YES

Author
ZHANG, Zheng

Source
ZJCPC2004

Recommend
JGShining
解题思路:很好的一道搜索题,关键是剪枝,
剪枝1:如果可以走的路径最长值仍小于所给时间t,则无法在时间t的时候到达出口;
剪枝2:如果当前位置距离出口最短值大于剩下的时间,也无法在时间t的时候到达出口;
剪枝3:如果当前位置距离出口的最短值与剩下时间的奇偶性不同,无法在时间t的时候到达出口;
这个很好证明,因为想要时间比最短时间长,势必被拖长的时间是一个偶数(在两点之间多绕的弯路除去和最短路径相等的部分必然可分为对称的两边),这样,不管怎么绕路径的奇偶性是不会变的。因此,满足条件的路径上的任意一点到出口处的最短值与剩下时间的奇偶性一定相同,不同的话,这条路径必然不符合要求,这就是所谓的奇偶剪枝,也是我做这一题最大收获。

#include
#include
using namespace std;
char maze[10][10];
bool visit[10][10];
int t;
bool DFS(int xa,int ya,int xb,int yb,int s)
{
    int l=t-s-(abs(xa-xb)+abs(ya-yb));
    if(l%2||l<0)
        return false;
    if((maze[xa][ya]!='.'&&maze[xa][ya]!='D'&&maze[xa][ya]!='S')||(visit[xa][ya]&&s)||s>t)
        return false;
    else if(xa==xb&&ya==yb&&s!=t)
        return false;
    else
        visit[xa][ya]=true;
    if(xa==xb&&ya==yb&&s==t)
        return true;
    if(DFS(xa+1,ya,xb,yb,s+1))//S
        return true;
    if(DFS(xa,ya+1,xb,yb,s+1))//E
        return true;
    if(DFS(xa-1,ya,xb,yb,s+1))//N
        return true;
    if(DFS(xa,ya-1,xb,yb,s+1))//W
        return true;
    if(maze[xa][ya]!='S')
        visit[xa][ya]=false;
    return false;
}
int main()
{
    int i,j,m,n,a,b,c,d,ncount;
    while(cin>>m>>n>>t&&(m||n||t))
    {
        ncount=0;
        memset(maze,'*',sizeof(maze));
        memset(visit,false,sizeof(visit));
        for(i=1;i<=m;i++)
            for(j=1;j<=n;j++)
            {
                cin>>maze[i][j];
                if(maze[i][j]=='S')
                {
                    a=i;b=j;
                }
                if(maze[i][j]=='D')
                {
                    c=i;d=j;
                }
                if(maze[i][j]=='.')
                    ncount++;
            }
            if(ncount+1printf("NO\n");
            continue;
        }
        if(DFS(a,b,c,d,0))
            printf("YES\n");
        else
            printf("NO\n");
    }
    return 0;
}

你可能感兴趣的:(算法练习)